=== debian/control ===
--- 
+++ 
@@ -35,8 +35,7 @@
  pkg-config,
  python-dev,
  python3-dev,
- python3-distutils | python3-dev (<< 3.6.4~rc1-2),
- tcl8.6-dev | tcl8.5-dev,
+ tcl8.6-dev,
  uuid-dev,
  xsltproc,
  zlib1g-dev | libz-dev
