=== debian/rules ===
--- 
+++ 
@@ -2,22 +2,11 @@
 
 include /usr/share/dpkg/architecture.mk
 
-ifneq ($(shell which tclsh8.6),)
+MAJOR_VER := 10
 TCL_VER := 8.6
-else
-TCL_VER := 8.5
-endif
-MAJOR_VER := 10
 #CASSERT_FLAGS := --enable-cassert
 
 CATVERSION = $(shell awk '/CATALOG_VERSION_NO/ { print $$3 }' src/include/catalog/catversion.h)
-
-# find tclconfig in multi-arch location (still in /usr/lib in wheezy and precise)
-ifneq ($(wildcard /usr/lib/$(DEB_HOST_MULTIARCH)/tcl$(TCL_VER)),)
-TCL_CONFIG_DIR := /usr/lib/$(DEB_HOST_MULTIARCH)
-else
-TCL_CONFIG_DIR := /usr/lib
-endif
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 #PIE# # On jessie/zesty and older, uncomment the #PIE# lines
@@ -49,12 +38,7 @@
 
 ifeq ($(DEB_HOST_ARCH_OS),linux)
 SYSTEMD_FLAGS = --with-systemd
-# --with-selinux needs libselinux 2.1.10
-# (we don't put that in debian/control so we can use the same source also on older dists)
-SEVERSION = $(shell dpkg-query -f '$${Version}' --show libselinux1-dev)
-ifeq ($(shell dpkg --compare-versions "$(SEVERSION)" ge 2.1.10 && echo yes),yes)
 SELINUX_FLAGS= --with-selinux
-endif
 endif
 
 COMMON_CONFIGURE_FLAGS= \
@@ -80,6 +64,7 @@
   --with-pgport=5432 \
   --with-system-tzdata=/usr/share/zoneinfo \
   $(SYSTEMD_FLAGS) \
+  $(SELINUX_FLAGS) \
   $(SPINLOCK_FLAGS) \
   CFLAGS='$(CFLAGS)' \
   LDFLAGS='$(LDFLAGS)'
@@ -94,14 +79,6 @@
 		 --with-libs=/usr/lib/$(DEB_HOST_MULTIARCH)/mit-krb5
 endif
 
-# build should fail on test suite failures on all arches
-TESTSUITE_FAIL_CMD=exit 1
-# hurd doesn't implement semaphores shared between processes yet; succeed anyway so they at least have libpq5
-# plperl currently fails on kfreebsd-*
-ifneq ($(filter $(DEB_HOST_ARCH), hurd-i386 kfreebsd-amd64 kfreebsd-i386),)
-TESTSUITE_FAIL_CMD=exit 0
-endif
-
 %:
 	dh $@
 
@@ -109,8 +86,8 @@
 override_dh_auto_configure-arch: stamp/configure-build stamp/configure-build-py3
 
 stamp/configure-build:
-	mkdir -p stamp build
-	cd build && ../configure \
+	mkdir -p stamp
+	dh_auto_configure --builddirectory=build -- \
            --with-icu \
            --with-tcl \
            --with-perl \
@@ -119,19 +96,18 @@
            --with-openssl \
            --with-libxml \
            --with-libxslt \
-           --with-tclconfig=$(TCL_CONFIG_DIR)/tcl$(TCL_VER) \
+           --with-tclconfig=/usr/lib/$(DEB_HOST_MULTIARCH)/tcl$(TCL_VER) \
            --with-includes=/usr/include/tcl$(TCL_VER) \
            PYTHON=/usr/bin/python \
            $(COMMON_CONFIGURE_FLAGS) \
-           $(BOOTSTRAP_FLAGS) \
-           $(SELINUX_FLAGS)
+           $(BOOTSTRAP_FLAGS)
 	# remove pre-built documentation
 	rm -fv doc/src/sgml/*-stamp
 	touch "$@"
 
 stamp/configure-build-py3:
-	mkdir -p stamp build-py3
-	cd build-py3 && ../configure \
+	mkdir -p stamp
+	dh_auto_configure --builddirectory=build-py3 -- \
            --with-python \
            PYTHON=/usr/bin/python3 \
            $(COMMON_CONFIGURE_FLAGS)
@@ -203,9 +179,30 @@
 	chmod 755 debian/libpq-dev/usr/bin/pg_config
 
 	# remove actual build path from Makefile.global for reproducibility
+	# set -f{debug,file}-prefix-map to module_srcdir (which is set in pgxs.mk)
 	sed -i -e "s!^abs_top_builddir.*!abs_top_builddir = /build/postgresql-$(MAJOR_VER)/build!" \
 	       -e "s!^abs_top_srcdir.*!abs_top_srcdir = /build/postgresql-$(MAJOR_VER)/build/..!" \
+	       -e 's!prefix-map=[^ ]*!prefix-map=$$(module_srcdir)=.!g' \
 	       debian/postgresql-server-dev-$(MAJOR_VER)/usr/lib/postgresql/$(MAJOR_VER)/lib/pgxs/src/Makefile.global
 
 	# these are shipped in the pl packages
 	bash -c "rm debian/postgresql-$(MAJOR_VER)/usr/share/postgresql/$(MAJOR_VER)/extension/{plperl,plpython,pltcl,*_pl}*"
+	bash -c "rm debian/postgresql-$(MAJOR_VER)/usr/lib/postgresql/$(MAJOR_VER)/lib/{plperl,plpython,pltcl,*_pl}*"
+
+	# record catversion in a file
+	echo $(CATVERSION) > debian/postgresql-$(MAJOR_VER)/usr/share/postgresql/$(MAJOR_VER)/catalog_version
+
+override_dh_install-indep:
+	dh_install --fail-missing
+
+	if [ -d debian/postgresql-doc-$(MAJOR_VER) ]; then set -e; \
+		install -d debian/postgresql-doc-$(MAJOR_VER)/usr/share/doc/postgresql-doc-$(MAJOR_VER)/tutorial; \
+		install src/tutorial/*.c src/tutorial/*.source src/tutorial/Makefile src/tutorial/README debian/postgresql-doc-$(MAJOR_VER)/usr/share/doc/postgresql-doc-$(MAJOR_VER)/tutorial; \
+	fi
+
+override_dh_auto_test-indep:
+	# nothing to do
+
+override_dh_auto_test-arch:
+ifeq (, $(findstring nocheck, $(DEB_BUILD_OPTIONS)))
+	# when tests fail, print newest 3 log files
